diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/illustration_view.cpp lmi-editor/illustration_view.cpp
--- cvs/illustration_view.cpp	2008-02-07 18:25:39.000000000 +0100
+++ lmi-editor/illustration_view.cpp	2008-02-08 15:04:03.000000000 +0100
@@ -65,6 +65,7 @@
 #include <wx/html/htmprint.h>
 #include <wx/icon.h>
 #include <wx/menu.h>
+#include <wx/utils.h> // wxBusyCursor
 #include <wx/xrc/xmlres.h>
 
 #include <sstream>
@@ -162,12 +163,6 @@
 void IllustrationView::DisplaySelectedValuesAsHtml()
 {
     // TODO ?? CALCULATION_SUMMARY Resolve this issue.
-    // EVGENIY This assertion seems no longer to serve any purpose:
-    // the object is no longer used here. Instead, shouldn't the
-    // validity of ledger_formatter_ be asserted?
-    LMI_ASSERT(ledger_values_.get());
-
-    // TODO ?? CALCULATION_SUMMARY Resolve this issue.
     // EVGENIY Is a stream the best abstraction for LedgerFormatter?
     // Apparently std::ostream.write() is the only stream function
     // that actually gets called. This code could be simpler if a
@@ -358,6 +353,7 @@
 
 void IllustrationView::Pdf(std::string const& action) const
 {
+    wxBusyCursor busy;
     LMI_ASSERT(ledger_values_.get());
 
     wxString z;
@@ -371,18 +367,6 @@
 // TODO ?? CALCULATION_SUMMARY This should use either the code or the
 // ideas in DocManagerEx::UponPreview().
 
-// TODO ?? CALCULATION_SUMMARY Resolve this issue.
-// EVGENIY Is it necessary to use scoped_ptr here? The wx
-// documentation says
-//   "Do not create this class on the stack only. You should create an
-//   instance on app startup and use this instance for all printing
-//   operations. The reason is that this class stores various settings
-//   in it."
-// But that reason doesn't hold here: settings don't persist anyway,
-// because the printing object is deleted as soon as this function
-// returns. Is there a different, unstated reason why we shouldn't
-// create it on the stack?
-
 void IllustrationView::PrintOrPreviewHtmlSummary(enum_print_option option) const
 {
     std::string disclaimer
@@ -390,11 +374,9 @@
         );
     // TODO ?? MPATROL !! Probably operator new(std::size_t, wx_allocator)
     // should be used here.
-    boost::scoped_ptr<wxHtmlEasyPrinting> printer
-        (new wxHtmlEasyPrinting("Calculation Summary", html_window_)
-        );
+    wxHtmlEasyPrinting printer("Calculation Summary", html_window_);
 
-    printer->SetHeader
+    printer.SetHeader
         (disclaimer + " (@PAGENUM@/@PAGESCNT@)<hr />"
         ,wxPAGE_ALL
         );
@@ -413,17 +395,17 @@
     // that the paper id was actually wxPAPER_NONE; if that causes
     // 'A4' to be used, then should wx instead use wxPAPER_LETTER in
     // a US locale, where 'A4' is a poor default?
-    printer->GetPrintData()->SetPaperId(wxPAPER_LETTER);
+    printer.GetPrintData()->SetPaperId(wxPAPER_LETTER);
 
     if(e_print_printer == option)
         {
-        printer->PrintText(selected_values_as_html_);
+        printer.PrintText(selected_values_as_html_);
         }
     // TODO ?? CALCULATION_SUMMARY This assumes, without asserting,
     // that the enumeration has exactly two enumerators.
     else
         {
-        printer->PreviewText(selected_values_as_html_);
+        printer.PreviewText(selected_values_as_html_);
         }
 }
 
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/inputillus_xml_io.cpp lmi-editor/inputillus_xml_io.cpp
--- cvs/inputillus_xml_io.cpp	2008-01-25 21:19:59.000000000 +0100
+++ lmi-editor/inputillus_xml_io.cpp	2008-01-30 21:04:28.000000000 +0100
@@ -253,7 +253,7 @@
         {
         std::string node_tag(*i);
         std::string value = operator[](*i).str();
-        root.push_back(xml::element(node_tag.c_str(), value.c_str()));
+        xml_lmi::add_node(root, node_tag, value);
         }
 
     x.push_back(root);
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/ledger_xml_io.cpp lmi-editor/ledger_xml_io.cpp
--- cvs/ledger_xml_io.cpp	2008-01-10 18:31:46.000000000 +0100
+++ lmi-editor/ledger_xml_io.cpp	2008-01-30 21:04:28.000000000 +0100
@@ -918,7 +918,7 @@
         {
         std::string node_tag = j->first;
         std::string value = j->second;
-        scalar.push_back(xml::element(node_tag.c_str(), value.c_str()));
+        xml_lmi::add_node(scalar, node_tag, value);
         }
     for
         (std::map<std::string,std::vector<std::string> >::const_iterator j = stringvectors.begin()
@@ -965,7 +965,7 @@
     if(ledger_invariant_->SupplementalReport)
         {
         // Eventually customize the report name.
-        supplementalreport.push_back(xml::element("title", "Supplemental Report"));
+        xml_lmi::add_node(supplementalreport, "title", "Supplemental Report");
 
         std::vector<std::string>::const_iterator j;
         for
@@ -975,8 +975,8 @@
             )
             {
             xml::element columns("columns");
-            columns.push_back(xml::element("name", (*j).c_str()));
-            columns.push_back(xml::element("title", title_map[*j].c_str()));
+            xml_lmi::add_node(columns, "name", *j);
+            xml_lmi::add_node(columns, "title", title_map[*j]);
             supplementalreport.push_back(columns);
             }
         }
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/main_wx.cpp lmi-editor/main_wx.cpp
--- cvs/main_wx.cpp	2008-02-07 18:25:52.000000000 +0100
+++ lmi-editor/main_wx.cpp	2008-02-08 15:09:46.000000000 +0100
@@ -1042,7 +1042,12 @@
 void Skeleton::UponUpdateFileSave(wxUpdateUIEvent& event)
 {
     wxDocument* doc = doc_manager_->GetCurrentDocument();
-    event.Enable(doc && doc->IsModified());
+
+    // Note that the condition is (IsModified() || !GetDocumentSaved()).
+    // IsModified() is not enough since a new empty document
+    // is not modified, but yet has to have 'Save' menu item enabled.
+    // The solution is to check for !GetDocumentSaved().
+    event.Enable(doc && (doc->IsModified() || !doc->GetDocumentSaved()));
 
     // Setting the event's Id to the xrc Id fails to handle menu
     // enablement--that is, this does not work:
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/Makefile.am lmi-editor/Makefile.am
--- cvs/Makefile.am	2008-02-02 12:23:07.000000000 +0100
+++ lmi-editor/Makefile.am	2008-01-30 21:04:27.000000000 +0100
@@ -92,6 +92,18 @@
     print-preview.xpm \
     rounding_view.xpm \
     rounding_view.xrc \
+    rounding_view_downward.xpm \
+    rounding_view_downward_hover.xpm \
+    rounding_view_downward_selected.xpm \
+    rounding_view_not_at_all.xpm \
+    rounding_view_not_at_all_hover.xpm \
+    rounding_view_not_at_all_selected.xpm \
+    rounding_view_to_nearest.xpm \
+    rounding_view_to_nearest_hover.xpm \
+    rounding_view_to_nearest_selected.xpm \
+    rounding_view_upward.xpm \
+    rounding_view_upward_hover.xpm \
+    rounding_view_upward_selected.xpm \
     run-case.xpm \
     run-cell.xpm \
     save.xpm \
